<?
// HTML2RGB v1.0
// Sylvain MACHEFERT
// http://iubito.free.fr
// Dmo et tutorial : http://iubito.free.fr/prog/html2rgb.php
//               ou : http://www.asp-php.net/scripts/asp-php/html2rgb.php

// La fonction crit du texte en dgrad
// Les paramtres $start et $end sont ici des valeurs HTML
function texteDegrade($text,$starthtml,$endhtml)
{
	$start=html2rgb($starthtml);
	$end=html2rgb($endhtml);
	$nb=strlen($text);
	if ($nb>0)
	{
		for ($i=0;$i<=$nb;$i++)
		{
			for ($j=0;$j<3;$j++) //Pour faire le Rouge, Vert, Bleu
			{
				$buffer[$j] = $start[$j] + ($i/$nb)*($end[$j]-$start[$j]);
			}
			echo "<font color=\"".rgb2html($buffer)."\">".substr($text,$i,1)."</font>";
		}
	}
}

//texteDegrade2 permet de faire des dgrads sur 2, 3, n couleurs
//texteDegrade2("Voyage en Italie","#00ff00|#ffffff|#ff0000")
//Dcoupage de "Voyage en Italie" en 2 => "Voyage e" et "n Italie"
//Dgrad vert=>blanc pour "Voyage e" et dgrad blanc=>rouge pour "n Italie"
function texteDegrade2($text,$couleurs)
{
	$couleurs=strtolower($couleurs);
	$preset["italie"] = "00ff00|ffffff|ff0000";
	$preset["france"] = "0000ff|ffffff|ff0000";
	$preset["roumanie"] = "0000ff|ffff00|ff0000";
	$preset["belgique"] = "000000|ffff00|ff0000";
	$preset["irlande"] = "00ff00|ffffff|ffa500";
	$preset["arcenciel"] = "ff0000|ffa500|ffff00|00ff00|0000ff|4B0082|9400D3";
	$preset["arcenciel2"] = "ff0000|ffa500|ffff00|00ff00|0000ff|4B0082|9400D3|9400D3|4B0082|0000ff|00ff00|ffff00|ffa500|ff0000";
	if ($preset[$couleurs]) $couleurs=$preset[$couleurs];

	$tablo=explode('|',$couleurs);
	$nb=sizeof($tablo)-1; //Nb de dgrad entre 2 couleurs

	$tablo2=explode('',decoupe($text,$nb));

	for ($i=0;$i<$nb;$i++)
	{
		texteDegrade($tablo2[$i],$tablo[$i],$tablo[$i+1]);
	}
}

//Fonction qui dcoupe une chaine $txt en $nb morceaux
function decoupe($txt,$nb)
{
	if(($nb<2)||($txt=="")) return $txt;
	else
	{
		$tmp = substr($txt,0,round(strlen($txt)/$nb));
		$txt2 = substr($txt,round(strlen($txt)/$nb));
		return $tmp."".decoupe($txt2,$nb-1);
	}
}



// Array html2rgb(string color)
// Ce code convertit les couleurs HTML (codes en hexa), en RGB :
function html2rgb($color)
{
	// gestion du #...
	if (substr($color,0,1)=="#") $color=substr($color,1,6);

	$tablo[0] = hexdec(substr($color, 0, 2));
	$tablo[1] = hexdec(substr($color, 2, 2));
	$tablo[2] = hexdec(substr($color, 4, 2));
	return $tablo;
}


// Une petite fonction utile pour borner les nombres entre 0 et 255.
function bornes($nb,$min,$max)
{
	if ($nb<$min) $nb=$min; // $nb est born bas
	if ($nb>$max) $nb=$max; // $nb est Borno (ah! la vieille blague de mon prof de maths ;-)) hihi !)
	return $nb;
}

// string rgb2html(Array tablo)
// La rciproque exacte de la fonction html2rgb, avec comme paramtre un Array.
function rgb2html($tablo)
{
	// Vrification des bornes...
	for($i=0;$i<=2;$i++)
	{
		$tablo[$i]=bornes($tablo[$i],0,255);
	}
	// Le str_pad permet de remplir avec des 0
	// parce que sinon rgb2html(Array(0,255,255)) retournerai #0ffff<=manque un 0 !
	return "#" . str_pad(dechex( ($tablo[0]<<16)|($tablo[1]<<8)|$tablo[2] ), 6, "0", STR_PAD_LEFT);
}
//print_r( html2rgb("#ff9900") );
?>